//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT" ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _BTRACE_
   #include "btrace.hpp"
#endif

#ifndef _GEPCIMCARD_
   #include "gepcimcard.hpp"
#endif

#ifndef _GEMICROGENI_
   #include "gemicrogeni.hpp"
#endif

#ifndef _STDEXCEPT_
   #include <stdexcept>
#endif

#ifndef _IOTRACK_
   #include "iotrack.hpp"
#endif

#ifndef _OSIFACE_
   #include "osiface.hpp"
#endif

using namespace std;
using namespace Uniio;


//-----------------------------------------------------------------------------
GEPCIMCard::GEPCIMCard ( const unsigned inBaseAddress
                       , const unsigned inType
                       )
   : theBaseIOAddress ( inBaseAddress )
   , theMotherboardType ( inType )
   , theChannelA (NULL)
   , theChannelB (NULL)
{
BFUNCTRACE_DEVELOP ();
} // end constructor

//-----------------------------------------------------------------------------
GEPCIMCard::~GEPCIMCard ()
{
BFUNCTRACE_DEVELOP ();
delete theChannelA;
delete theChannelB;
} // end destructor


//-----------------------------------------------------------------------------
GEPCIMCard & GEPCIMCard::addMicroGENI ( const unsigned inIOPortAddress
                             , const unsigned long inSharedRamAddress
                             )
{
BFUNCTRACE_DEVELOP ();
if (!theChannelA)
{
   theChannelA = new GEMicroGENI (inIOPortAddress, inSharedRamAddress);
} // end if
else
{
   if (!theChannelB && motherboardType() == dualChannel)
   {
      theChannelB = new GEMicroGENI (inIOPortAddress, inSharedRamAddress);
   }
   else
   {
      throw runtime_error ("Cannot add more MicroGENI doughterboards");
   }
} // end if else
return *this;
} // end GEPCIMCard::addMicroGENI (..)

