//=============================================================================
//  Unified IO - C++ interface for industrial IO cards
//  Copyright (C) 2000, UAB "BBD SOFT" ( http://www.bbdsoft.com/ )
//  Parts Copyright 1998-2000 Yariv Kaplan http://www.internals.com  
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================


#ifndef _BTRACE_
   #include "btrace.hpp"
#endif

#ifndef _OSIFACE_
   #include "osiface.hpp"
#endif

#ifndef _STDEXCEPT_
   #include <stdexcept>
#endif

#ifndef _WINDOWS_
   #define WIN32_LEAN_AND_MEAN
   #include <windows.h>
#endif


#define VWIN32_DPMI_CALL 0x2A0029

// KERNEL32's undocumented VxDCall function is located at linear address 0xBFF713D4

DWORD (WINAPI *VxDCall)(DWORD Service, DWORD EAX_Reg, DWORD ECX_Reg) = 
  (DWORD (WINAPI *)(DWORD,DWORD,DWORD)) 0xBFF713D4;

#define DPMICall(EAX_Reg, ECX_Reg) VxDCall(VWIN32_DPMI_CALL, EAX_Reg, ECX_Reg)

using namespace std;
using namespace Uniio;

OSInterface * OSInterface::theInterface = NULL;

//-----------------------------------------------------------------------------
OSInterface & OSInterface::osinterface ()
{
BFUNCTRACE_DEVELOP ();

//If it is first call to the function - create Operating system interface object
if (!theInterface)
{
   theInterface = new OSInterface;
} // endif

return * theInterface;
} // end OSInterface::osinterface()


//-----------------------------------------------------------------------------
OSInterface::OSInterface ()
{
BFUNCTRACE_DEVELOP ();
} // end constructor


//-----------------------------------------------------------------------------
OSInterface::~OSInterface ()
{
BFUNCTRACE_DEVELOP ();
} // end destructor


//-----------------------------------------------------------------------------
void * OSInterface::mapMemory ( unsigned long inAddress
                              , unsigned long inBlockSize
                              , bool fWriteAccess
                              )
{
BFUNCTRACE_DEVELOP ();

PBYTE linearAddress;

_asm
{
   Mov BX, WORD PTR [inAddress + 2]
   Mov CX, WORD PTR [inAddress]
   Mov SI, WORD PTR [inBlockSize + 2]
   Mov DI, WORD PTR [inBlockSize]
}

// Call DPMI function MapPhysicalToLinear
DPMICall(0x800, (DWORD)inAddress);    

_asm
{
   Jnc Success
   Xor BX, BX
   Xor CX, CX

Success:
   Mov WORD PTR [linearAddress + 2], BX
   Mov WORD PTR [linearAddress], CX
}

return linearAddress;
} // end OSInterface::mapMemory (..)


//-----------------------------------------------------------------------------
OSInterface & OSInterface::unmapMemory ( void * inVirtualAddress )
{
BFUNCTRACE_DEVELOP ();

return * this;
} // end OSInterface::unmapMemory (..)


//-----------------------------------------------------------------------------
void OSInterface::sleep ( const unsigned long inMicroseconds )
{
BFUNCTRACE_DEVELOP ();

Sleep ( inMicroseconds/1000 );

} // end OSInterface::sleep (..)
